/* File misc.h.  */
#ifndef FILE_MISC_SEEN
#define FILE_MISC_SEEN

#include "tree.h"

	int **allocateMemoryMatrixInt(int nrows, int ncols);
	
	double **allocateMemoryMatrixFloat(int nrows, int ncols);
	
	Node ***allocateMemoryMatrixNode(int nrows, int ncols);

	void initMatrixInt(int **array, int nrows, int ncols, int value);
	
	void initMatrixFloat(double **array, int nrows, int ncols, int value);
	
	void initMatrixNode(Node ***array, int nrows, int ncols, Node *value);	
	
	void initArrayFloat (double *array, int nrows, int value);

	void printMatrixInt(int **array, int nrows, int ncols);
	
	void printMatrixFloat(double **array, int nrows, int ncols);
	
	void printMatrixNode(Node ***array, int nrows, int ncols);
	
	void printArrayFloat (double *array, int nrows);
	
	void printArrayF (Node ***array, int nrows, int ncols);
	
	void freeMemoryMatrix (void **array, int nrows);
	
	void freeMemoryMatrix2 (Node ***array, int nrows);

	char* substring(const char* str, int begin, int len);
	
	char *trimWhitespace(char *str);
	
	int isValidSpName (char *sp, char **arr_allSp, int numberSpecies);


#endif /* !FILE_MISC_SEEN */